package at.xaxa.ledger.ui.home

import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import at.xaxa.ledger.data.Entry
import at.xaxa.ledger.data.EntryRepository
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.flowOf
import kotlinx.coroutines.launch
import kotlinx.coroutines.withContext


data class EntryListUIState(val entry: Flow<List<Entry>> = flowOf(emptyList()))

class HomeViewModel(private val repository: EntryRepository): ViewModel() {
    var entryUIState by mutableStateOf(EntryListUIState())
    init{
        viewModelScope.launch {
            val entries = withContext(Dispatchers.IO){
                repository.getAllEntries()
            }
            entryUIState = EntryListUIState(entries)

        }
    }

   /* val entryUIState = repository.getAllEntries()
        .map {EntryListUIState(it)}
        .stateIn(
            scope = viewModelScope,
            started = SharingStarted.WhileSubscribed(5000),
            initialValue = EntryListUIState(emptyList())
        )*/
}